diskimage-builder/diskimage_builder/elements/yum/bin/install-packages
Ian Wienand 97c01e48ed Move elements & lib relative to diskimage_builder package
Currently we have all our elements and library files in a top-level
directory and install them into
<root>/share/diskimage-builder/[elements|lib] (where root is either /
or the root of a virtualenv).

The problem with this is that editable/development installs (pip -e)
do *not* install data_files.  Thus we have no canonical location to
look for elements -- leading to the various odd things we do such as a
whole bunch of guessing at the top of disk-image-create and having a
special test-loader in tests/test_elements.py so we can run python
unit tests on those elements that have it.

data_files is really the wrong thing to use for what are essentially
assets of the program.  data_files install works well for things like
config-files, init.d files or dropping documentation files.

By moving the elements under the diskimage_builder package, we always
know where they are relative to where we import from.  In fact,
pkg_resources has an api for this which we wrap in the new
diskimage_builder/paths.py helper [1].

We use this helper to find the correct path in the couple of places we
need to find the base-elements dir, and for the paths to import the
library shell functions.

Elements such as svc-map and pkg-map include python unit-tests, which
we do not need tests/test_elements.py to special-case load any more.
They just get found automatically by the normal subunit loader.

I have a follow-on change (I69ca3d26fede0506a6353c077c69f735c8d84d28)
to move disk-image-create to a regular python entry-point.

Unfortunately, this has to move to work with setuptools.  You'd think
a symlink under diskimage_builder/[elements|lib] would work, but it
doesn't.

[1] this API handles stuff like getting files out of .zip archive
modules, which we don't do.  Essentially for us it's returning
__file__.

Change-Id: I5e3e3c97f385b1a4ff2031a161a55b231895df5b
2016-11-01 17:27:41 -07:00

151 lines
4.4 KiB
Bash
Executable File

#!/bin/bash
# Copyright 2012 Hewlett-Packard Development Company, L.P.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may
# not use this file except in compliance with the License. You may obtain
# a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
# License for the specific language governing permissions and limitations
# under the License.
if [ ${DIB_DEBUG_TRACE:-0} -gt 1 ]; then
set -x
fi
set -eu
set -o pipefail
EXTRA_ARGS=
ACTION=install
MAP_ELEMENT=
# allow override for dnf, as shipped by default with >=F22
YUM=${YUM:-yum}
SCRIPTNAME=$(basename $0)
function show_options () {
echo "Usage: $SCRIPTNAME [package ...]"
echo
echo "Options:"
echo " -u -- update all packages"
echo " -d dir -- download the packages to directory"
echo " -e -- erase/remove packages"
echo " -m map -- use custom element package map (Example: -m nova)"
exit 0
}
while getopts "hud:em:" opt; do
case "$opt" in
u)
${YUM} -y update;
exit 0
;;
d)
ACTION="download"
DOWNLOAD_PATH=$OPTARG
;;
e)
ACTION="erase"
;;
m)
MAP_ELEMENT=$OPTARG
;;
h)
show_options
;;
*)
exit 1
;;
esac
done
shift $((OPTIND-1))
# Packages that aren't available in the distro but requested for installation
# can be ignored by adding them to the exclude list
BLACKLIST=$(cat /tmp/yum-blacklist 2>/dev/null || echo "")
WHITELIST=""
for i in "$@"
do
PKG_NAME=$i
if [ -n "$MAP_ELEMENT" ]; then
if ! PKG_NAME=$(pkg-map --element $MAP_ELEMENT $i); then
echo "bin/pkg-map error. $PKG_NAME"
exit 1
fi
fi
if [[ ! ${BLACKLIST[*]} =~ $PKG_NAME ]]; then
WHITELIST="$WHITELIST $i"
else
echo "The package $i is not available and will not be installed"
fi
done
if [ -n "$WHITELIST" ]; then
if [ -f /etc/pki/rpm-gpg/RPM-GPG-KEY-redhat-release ]; then
rpm --import /etc/pki/rpm-gpg/RPM-GPG-KEY-redhat-release
fi
if [ -n "$MAP_ELEMENT" ]; then
if ! PKGS=$(pkg-map --element $MAP_ELEMENT $WHITELIST); then
echo "bin/pkg-map error. $PKGS"
exit 1
fi
else
PKGS=$(map-packages $WHITELIST)
fi
if [ -z "${PKGS}" ]; then
echo "Not running install-packages $ACTION with empty packages list"
exit 0
fi
echo "Running install-packages ${ACTION}. Package list: $PKGS"
if [ "$ACTION" == "download" ]; then
mkdir -p $DOWNLOAD_PATH
if [ ${YUM} == "dnf" ]; then
dnf download --destdir=$DOWNLOAD_PATH $PKGS
else
# note; you don't want to use yum --download only here.
# Firstly that only puts things in the yum cache
# directory, and secondly it acts funny if old versions
# are already in the cache.
if [ ! -f /usr/bin/yumdownloader ]; then
yum install -y yum-utils
fi
yumdownloader --destdir=$DOWNLOAD_PATH $PKGS
fi
exit 0
fi
# yum & dnf have a feature/bug where missing packages in a list of
# packages for install/erase do not raise an error exit [1].
# There is a corner case when specifying just *one* package, where
# it will fail if the package is missing. Thus install-packages
# follows this behaviour; we may need to re-evaluate this at some
# point.
#
# [1] https://bugzilla.redhat.com/show_bug.cgi?id=965567
${YUM} -v -y $ACTION $EXTRA_ARGS $PKGS
if [ "$ACTION" == "install" ]; then
if [ ${YUM} == "dnf" ]; then
# Make sure dnf won't autoremove these packages
dnf mark install $PKGS
fi
fi
# probably not the right place for this; but python-pip package on
# fedora/rh calls pip "pip-python" while the rest of the work
# expects it to be just called "pip"
for pkg in "$@"; do
if [ "$pkg" = "python-pip" ] ; then
alternatives --install /usr/bin/pip pip /usr/bin/pip-python 10
fi
done
fi